// C Source File
// Created 8/10/2004; 11:23:28 PM
#define MIN_AMS 200
#include "Edefs.h"

void loadSet(SET *dest){
	SET *src;
	SYM_ENTRY *file=SymFindPtr(SYMSTR("jset"),4);
	if(!file)return;
	src=HeapDeref(file->handle)+2;
	memcpy(dest,src,sizeof(SET));
}

void saveSet(SET *save){
	EM_moveSymFromExtMem(SYMSTR("jset"),HS_NULL);
	HANDLE fileh=HeapAlloc(2+sizeof(SET)+6);
	if(!fileh)return;
	void *dest;
	SYM_ENTRY *file=DerefSym(SymAdd(SYMSTR("jset")));
	if(!file){
		HeapFree(fileh);
		return;
	}
	file->handle=fileh;
	dest=HeapDeref(fileh);
	*(unsigned short*)dest=sizeof(SET)+6;
	memcpy(dest+2,save,sizeof(SET));
	memcpy(dest+sizeof(SET)+2,(char[6]){0,'S','E','T',0,OTH_TAG},6);
	EM_moveSymToExtMem(SYMSTR("jset"),HS_NULL);
}

short save(HSym dest,LEVEL *save,unsigned short Type){
	EM_moveSymFromExtMem(NULL,dest);
	SYM_ENTRY *symptr=DerefSym(dest);
	void *fptr;
	if(!symptr)return FALSE;
	unsigned short size;
	if(symptr->flags.bits.archived)return FALSE;
	HANDLE fileh=symptr->handle;
	fptr=HeapDeref(fileh);
	if(Type!=3){
		if(save->ll){
			size=92;
			*(short*)fptr=98+(Type==1);
		}else{
			size=101;
			*(short*)fptr=107+(Type==1);
		}
		memcpy(fptr+2,save,size);
		memcpy(fptr+size+2,fltgs[(Type-1)],6+(Type==1));
	}else{
		memcpy(fptr+4+90*save->ll,save->bricks,90);
	}
	return TRUE;
}

HSym new(LEVEL *new,unsigned short *Type){
  char buff[10];
  HSym hsFile;
  HANDLE fileh;
  SYM_ENTRY *file;
  void *flptr;
  if(!(hsFile=VarNew(tags,exts)).folder){
		return HS_NULL;
  }
  memset(new,0,sizeof(LEVEL));
  *Type=*VarOptList;
	if(*Type!=3){
		new->ll=1;
		fileh=HeapAlloc(100+(*Type==1));
		if(!(file=DerefSym(hsFile))){
			return HS_NULL;
		}
		file->handle=fileh;
		flptr=HeapDeref(fileh);
		*(unsigned short*)flptr=98+(*Type==1);
		memcpy(flptr+2,new,92);
		memcpy(flptr+94,fltgs[(*Type-1)],6+(*Type==1));
	}else{
		new->ll=2;
		for(;;){
			sprintf(buff,"%i",new->ll);
			if(KEY_ESC==Dialog(&NewLSet,CENTER,CENTER,buff,NULL)){
				HSymDel(hsFile);
				return HS_NULL;
			}
			new->ll=atoi(buff);
			if((signed)new->ll>=2)break;
			DlgMessage("Jedit "VERSION_STR,"You must have at least 2 Levels in a level set",BT_OK,BT_NONE);
		}
		fileh=HeapAlloc(4+90*new->ll+7);
		if(!(file=DerefSym(hsFile))){
			return HS_NULL;
		}
		file->handle=fileh;
		flptr=HeapDeref(fileh);
		memset(flptr,0,4+90*new->ll+7);
		*(unsigned short*)flptr=2+90*new->ll+7;
		*(unsigned short*)(flptr+2)=new->ll;
		memcpy(flptr+4+90*new->ll,fltgs[2],7);
		new->ll=0;
	}
	return hsFile;
}

HSym openFile(LEVEL *open,unsigned short *Type){
  HSym src;
  SYM_ENTRY *file;
  void *flptr;
  if(!(src=VarOpen(tags,exts)).folder){
		return HS_NULL;
  }
  EM_moveSymFromExtMem(NULL,src);
  *Type=*VarOptList;
  if((file=DerefSym(src))){
  	if(file->flags.bits.archived)return HS_NULL;
		flptr=HeapDeref(file->handle);
	  if(*Type!=3){
	  	memcpy(open,flptr+2,92);
	  	if(!open->ll){
				memcpy(open->nlevel,flptr+94,9);
	  	}
	  }else{
			memcpy(open->bricks,flptr+4,90);
			open->ll=0;
	  }
  }else{
  	return HS_NULL;
  }
	return src;
}
