// C Source File
// Created 8/6/2004; 11:12:56 AM

	typedef struct{
		//total size of the level set
		unsigned short symSize;
		//number of levels in the level set
		unsigned short numL;
		//an aray that holdes the data for each level
		unsigned char bricks[][9][10];
	}L_SET;
#define NO_CALC_DETECT
#define ENABLE_ERROR_RETURN
#define OPTIMIZE_ROM_CALLS
#include <tigcclib.h>

// Main Function
void _main(void)
{

	//we must coppy top_estack because getSymstrArg modifys te value passed to it
	CESI arg=top_estack;
	//loop counter and the number of levels that we will have in our level set
	int i,numLevels=(ArgCount())-1;
	//where we store our data
	L_SET *dest;
	SYM_ENTRY *sym=NULL;
	//handle to coppy data to
	HANDLE fileh;
	//make sure that there is at least 3 args
	//one for the dest and atleast two to add
	//to the level set
	if(numLevels<2)ER_throw(TOO_FEW_ARGS_ERROR);
	//chaeck if first arg is a string
	if(GetArgType(arg)!=STR_TAG)
		ER_throw(ER_ARG_MUST_BE_STRING);
	const char *destName=GetSymstrArg(arg),*name;
	//we allocate the memory so we can fill it befor we add the dest
	//to the vat incase one of the levels we coppy from has the same name
	//we need sizeof(L_SET) bytes for the lenth of the file and number of levels +
	//numLevels*90 bytes data for the levels + 7 for the "lset" tag
	if(!(fileh=HeapAlloc(sizeof(L_SET)+numLevels*90+7))){
		ER_throw(ER_MEMORY);
	}
	//get pointer to newley allocated memory
	dest=HeapDeref(fileh);
	for(i=0;i<numLevels;i++){
		//make sure that the current arg is a string
		if(GetArgType(arg)!=STR_TAG){
			//if not a sting free memory and throw an error
			HeapFree(fileh);
			ER_throw(ER_ARG_MUST_BE_STRING);
		}
		//get the pointer to the last(zero) byte of the string
		name=GetSymstrArg(arg);
		//make sure tat the file that we coppy from exists
		if(!SymFind(name).folder){
			//it does not exist free memory and throw an error
			HeapFree(fileh);
			ER_throw(ER_INVALID_PATHNAME);
		}
		sym=DerefSym(SymFind(name));
		//make sure that it is a level file that we are copping from
		if(0!=strcmp(HToESI(sym->handle)-4,"lvl") && 0!=strcmp(HToESI(sym->handle)-5,"flvl")){
			//if it is not a level file free memory and throw an error
			HeapFree(fileh);
			ER_throw(ER_INVALID_PATHNAME);
		}
		//everything is good, coppy the data into the struct
		memcpy(dest->bricks[i],HeapDeref(sym->handle)+4,90);
	}
	//set the syize byte to the correct value
	dest->symSize=sizeof(L_SET)+numLevels*90+5;
	//enter the correct number of levels
	dest->numL=numLevels;
	//add the "lset" tag string
	memcpy(dest->bricks[i],(char[7]){0,'l','s','e','t',0,0xF8},7);
	//add the destination file
	if(!(sym=DerefSym(SymAdd(destName)))){
		//somthing is wrong free level set data
		//and return
		HeapFree(fileh);
		ER_throw(ER_MEMORY_DML);
	}
	//attach the data we have coppied to the newley created symbol
	sym->handle=fileh;

}
